
package de.bsvrz.sys.startstopp.api.jsonschema;

import java.io.Serializable;
import java.util.HashMap;
import java.util.Map;
import com.fasterxml.jackson.annotation.JsonAnyGetter;
import com.fasterxml.jackson.annotation.JsonAnySetter;
import com.fasterxml.jackson.annotation.JsonCreator;
import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonInclude;
import com.fasterxml.jackson.annotation.JsonProperty;
import com.fasterxml.jackson.annotation.JsonPropertyDescription;
import com.fasterxml.jackson.annotation.JsonPropertyOrder;
import com.fasterxml.jackson.annotation.JsonValue;

@JsonInclude(JsonInclude.Include.NON_NULL)
@JsonPropertyOrder({
    "inkarnation",
    "rechner",
    "anzahlStarts",
    "letzteStartzeit",
    "letzteStartzeitSeconds",
    "letzteInitialisierung",
    "letzteStoppzeit",
    "letzteStoppzeitSeconds",
    "status",
    "startMeldung",
    "geaendert"
})
public class Applikation implements Serializable
{

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    private Inkarnation inkarnation;
    @JsonProperty("rechner")
    private String rechner;
    /**
     * die Anzahl der Start der zugehörigen Inkarnation
     * 
     */
    @JsonProperty("anzahlStarts")
    @JsonPropertyDescription("die Anzahl der Start der zugeh\u00f6rigen Inkarnation")
    private Integer anzahlStarts;
    /**
     * die letzte Startzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStartzeit")
    @JsonPropertyDescription("die letzte Startzeit der Inkarnation")
    private String letzteStartzeit;
    /**
     * die letzte Startzeit in Sekunden seit 1.1.1970 GMT
     * 
     */
    @JsonProperty("letzteStartzeitSeconds")
    @JsonPropertyDescription("die letzte Startzeit in Sekunden seit 1.1.1970 GMT")
    private Integer letzteStartzeitSeconds;
    /**
     * die letzte Initialisierungszeit der Inkarnation
     * 
     */
    @JsonProperty("letzteInitialisierung")
    @JsonPropertyDescription("die letzte Initialisierungszeit der Inkarnation")
    private String letzteInitialisierung;
    /**
     * die letzte Stoppzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStoppzeit")
    @JsonPropertyDescription("die letzte Stoppzeit der Inkarnation")
    private String letzteStoppzeit;
    /**
     * die letzte Stoppzeit in Sekunden seit 1.1.1970 GMT
     * 
     */
    @JsonProperty("letzteStoppzeitSeconds")
    @JsonPropertyDescription("die letzte Stoppzeit in Sekunden seit 1.1.1970 GMT")
    private Integer letzteStoppzeitSeconds;
    /**
     * der Status der Inkarnation in StartStopp
     * (Required)
     * 
     */
    @JsonProperty("status")
    @JsonPropertyDescription("der Status der Inkarnation in StartStopp")
    private Applikation.Status status;
    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startMeldung")
    private String startMeldung;
    @JsonProperty("geaendert")
    private Boolean geaendert;
    @JsonIgnore
    private Map<String, Object> additionalProperties = new HashMap<String, Object>();
    private final static long serialVersionUID = 1730134145764447423L;

    /**
     * No args constructor for use in serialization
     * 
     */
    public Applikation() {
    }

    /**
     * 
     * @param rechner
     * @param letzteInitialisierung
     * @param startMeldung
     * @param letzteStartzeit
     * @param letzteStoppzeit
     * @param letzteStoppzeitSeconds
     * @param anzahlStarts
     * @param geaendert
     * @param letzteStartzeitSeconds
     * @param inkarnation
     * @param status
     */
    public Applikation(Inkarnation inkarnation, String rechner, Integer anzahlStarts, String letzteStartzeit, Integer letzteStartzeitSeconds, String letzteInitialisierung, String letzteStoppzeit, Integer letzteStoppzeitSeconds, Applikation.Status status, String startMeldung, Boolean geaendert) {
        super();
        this.inkarnation = inkarnation;
        this.rechner = rechner;
        this.anzahlStarts = anzahlStarts;
        this.letzteStartzeit = letzteStartzeit;
        this.letzteStartzeitSeconds = letzteStartzeitSeconds;
        this.letzteInitialisierung = letzteInitialisierung;
        this.letzteStoppzeit = letzteStoppzeit;
        this.letzteStoppzeitSeconds = letzteStoppzeitSeconds;
        this.status = status;
        this.startMeldung = startMeldung;
        this.geaendert = geaendert;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    public Inkarnation getInkarnation() {
        return inkarnation;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("inkarnation")
    public void setInkarnation(Inkarnation inkarnation) {
        this.inkarnation = inkarnation;
    }

    public Applikation withInkarnation(Inkarnation inkarnation) {
        this.inkarnation = inkarnation;
        return this;
    }

    @JsonProperty("rechner")
    public String getRechner() {
        return rechner;
    }

    @JsonProperty("rechner")
    public void setRechner(String rechner) {
        this.rechner = rechner;
    }

    public Applikation withRechner(String rechner) {
        this.rechner = rechner;
        return this;
    }

    /**
     * die Anzahl der Start der zugehörigen Inkarnation
     * 
     */
    @JsonProperty("anzahlStarts")
    public Integer getAnzahlStarts() {
        return anzahlStarts;
    }

    /**
     * die Anzahl der Start der zugehörigen Inkarnation
     * 
     */
    @JsonProperty("anzahlStarts")
    public void setAnzahlStarts(Integer anzahlStarts) {
        this.anzahlStarts = anzahlStarts;
    }

    public Applikation withAnzahlStarts(Integer anzahlStarts) {
        this.anzahlStarts = anzahlStarts;
        return this;
    }

    /**
     * die letzte Startzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStartzeit")
    public String getLetzteStartzeit() {
        return letzteStartzeit;
    }

    /**
     * die letzte Startzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStartzeit")
    public void setLetzteStartzeit(String letzteStartzeit) {
        this.letzteStartzeit = letzteStartzeit;
    }

    public Applikation withLetzteStartzeit(String letzteStartzeit) {
        this.letzteStartzeit = letzteStartzeit;
        return this;
    }

    /**
     * die letzte Startzeit in Sekunden seit 1.1.1970 GMT
     * 
     */
    @JsonProperty("letzteStartzeitSeconds")
    public Integer getLetzteStartzeitSeconds() {
        return letzteStartzeitSeconds;
    }

    /**
     * die letzte Startzeit in Sekunden seit 1.1.1970 GMT
     * 
     */
    @JsonProperty("letzteStartzeitSeconds")
    public void setLetzteStartzeitSeconds(Integer letzteStartzeitSeconds) {
        this.letzteStartzeitSeconds = letzteStartzeitSeconds;
    }

    public Applikation withLetzteStartzeitSeconds(Integer letzteStartzeitSeconds) {
        this.letzteStartzeitSeconds = letzteStartzeitSeconds;
        return this;
    }

    /**
     * die letzte Initialisierungszeit der Inkarnation
     * 
     */
    @JsonProperty("letzteInitialisierung")
    public String getLetzteInitialisierung() {
        return letzteInitialisierung;
    }

    /**
     * die letzte Initialisierungszeit der Inkarnation
     * 
     */
    @JsonProperty("letzteInitialisierung")
    public void setLetzteInitialisierung(String letzteInitialisierung) {
        this.letzteInitialisierung = letzteInitialisierung;
    }

    public Applikation withLetzteInitialisierung(String letzteInitialisierung) {
        this.letzteInitialisierung = letzteInitialisierung;
        return this;
    }

    /**
     * die letzte Stoppzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStoppzeit")
    public String getLetzteStoppzeit() {
        return letzteStoppzeit;
    }

    /**
     * die letzte Stoppzeit der Inkarnation
     * 
     */
    @JsonProperty("letzteStoppzeit")
    public void setLetzteStoppzeit(String letzteStoppzeit) {
        this.letzteStoppzeit = letzteStoppzeit;
    }

    public Applikation withLetzteStoppzeit(String letzteStoppzeit) {
        this.letzteStoppzeit = letzteStoppzeit;
        return this;
    }

    /**
     * die letzte Stoppzeit in Sekunden seit 1.1.1970 GMT
     * 
     */
    @JsonProperty("letzteStoppzeitSeconds")
    public Integer getLetzteStoppzeitSeconds() {
        return letzteStoppzeitSeconds;
    }

    /**
     * die letzte Stoppzeit in Sekunden seit 1.1.1970 GMT
     * 
     */
    @JsonProperty("letzteStoppzeitSeconds")
    public void setLetzteStoppzeitSeconds(Integer letzteStoppzeitSeconds) {
        this.letzteStoppzeitSeconds = letzteStoppzeitSeconds;
    }

    public Applikation withLetzteStoppzeitSeconds(Integer letzteStoppzeitSeconds) {
        this.letzteStoppzeitSeconds = letzteStoppzeitSeconds;
        return this;
    }

    /**
     * der Status der Inkarnation in StartStopp
     * (Required)
     * 
     */
    @JsonProperty("status")
    public Applikation.Status getStatus() {
        return status;
    }

    /**
     * der Status der Inkarnation in StartStopp
     * (Required)
     * 
     */
    @JsonProperty("status")
    public void setStatus(Applikation.Status status) {
        this.status = status;
    }

    public Applikation withStatus(Applikation.Status status) {
        this.status = status;
        return this;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startMeldung")
    public String getStartMeldung() {
        return startMeldung;
    }

    /**
     * 
     * (Required)
     * 
     */
    @JsonProperty("startMeldung")
    public void setStartMeldung(String startMeldung) {
        this.startMeldung = startMeldung;
    }

    public Applikation withStartMeldung(String startMeldung) {
        this.startMeldung = startMeldung;
        return this;
    }

    @JsonProperty("geaendert")
    public Boolean getGeaendert() {
        return geaendert;
    }

    @JsonProperty("geaendert")
    public void setGeaendert(Boolean geaendert) {
        this.geaendert = geaendert;
    }

    public Applikation withGeaendert(Boolean geaendert) {
        this.geaendert = geaendert;
        return this;
    }

    @JsonAnyGetter
    public Map<String, Object> getAdditionalProperties() {
        return this.additionalProperties;
    }

    @JsonAnySetter
    public void setAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
    }

    public Applikation withAdditionalProperty(String name, Object value) {
        this.additionalProperties.put(name, value);
        return this;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(Applikation.class.getName()).append('@').append(Integer.toHexString(System.identityHashCode(this))).append('[');
        sb.append("inkarnation");
        sb.append('=');
        sb.append(((this.inkarnation == null)?"<null>":this.inkarnation));
        sb.append(',');
        sb.append("rechner");
        sb.append('=');
        sb.append(((this.rechner == null)?"<null>":this.rechner));
        sb.append(',');
        sb.append("anzahlStarts");
        sb.append('=');
        sb.append(((this.anzahlStarts == null)?"<null>":this.anzahlStarts));
        sb.append(',');
        sb.append("letzteStartzeit");
        sb.append('=');
        sb.append(((this.letzteStartzeit == null)?"<null>":this.letzteStartzeit));
        sb.append(',');
        sb.append("letzteStartzeitSeconds");
        sb.append('=');
        sb.append(((this.letzteStartzeitSeconds == null)?"<null>":this.letzteStartzeitSeconds));
        sb.append(',');
        sb.append("letzteInitialisierung");
        sb.append('=');
        sb.append(((this.letzteInitialisierung == null)?"<null>":this.letzteInitialisierung));
        sb.append(',');
        sb.append("letzteStoppzeit");
        sb.append('=');
        sb.append(((this.letzteStoppzeit == null)?"<null>":this.letzteStoppzeit));
        sb.append(',');
        sb.append("letzteStoppzeitSeconds");
        sb.append('=');
        sb.append(((this.letzteStoppzeitSeconds == null)?"<null>":this.letzteStoppzeitSeconds));
        sb.append(',');
        sb.append("status");
        sb.append('=');
        sb.append(((this.status == null)?"<null>":this.status));
        sb.append(',');
        sb.append("startMeldung");
        sb.append('=');
        sb.append(((this.startMeldung == null)?"<null>":this.startMeldung));
        sb.append(',');
        sb.append("geaendert");
        sb.append('=');
        sb.append(((this.geaendert == null)?"<null>":this.geaendert));
        sb.append(',');
        sb.append("additionalProperties");
        sb.append('=');
        sb.append(((this.additionalProperties == null)?"<null>":this.additionalProperties));
        sb.append(',');
        if (sb.charAt((sb.length()- 1)) == ',') {
            sb.setCharAt((sb.length()- 1), ']');
        } else {
            sb.append(']');
        }
        return sb.toString();
    }

    @Override
    public int hashCode() {
        int result = 1;
        result = ((result* 31)+((this.rechner == null)? 0 :this.rechner.hashCode()));
        result = ((result* 31)+((this.letzteInitialisierung == null)? 0 :this.letzteInitialisierung.hashCode()));
        result = ((result* 31)+((this.startMeldung == null)? 0 :this.startMeldung.hashCode()));
        result = ((result* 31)+((this.letzteStartzeit == null)? 0 :this.letzteStartzeit.hashCode()));
        result = ((result* 31)+((this.letzteStoppzeitSeconds == null)? 0 :this.letzteStoppzeitSeconds.hashCode()));
        result = ((result* 31)+((this.letzteStartzeitSeconds == null)? 0 :this.letzteStartzeitSeconds.hashCode()));
        result = ((result* 31)+((this.inkarnation == null)? 0 :this.inkarnation.hashCode()));
        result = ((result* 31)+((this.letzteStoppzeit == null)? 0 :this.letzteStoppzeit.hashCode()));
        result = ((result* 31)+((this.anzahlStarts == null)? 0 :this.anzahlStarts.hashCode()));
        result = ((result* 31)+((this.additionalProperties == null)? 0 :this.additionalProperties.hashCode()));
        result = ((result* 31)+((this.geaendert == null)? 0 :this.geaendert.hashCode()));
        result = ((result* 31)+((this.status == null)? 0 :this.status.hashCode()));
        return result;
    }

    @Override
    public boolean equals(Object other) {
        if (other == this) {
            return true;
        }
        if ((other instanceof Applikation) == false) {
            return false;
        }
        Applikation rhs = ((Applikation) other);
        return (((((((((((((this.rechner == rhs.rechner)||((this.rechner!= null)&&this.rechner.equals(rhs.rechner)))&&((this.letzteInitialisierung == rhs.letzteInitialisierung)||((this.letzteInitialisierung!= null)&&this.letzteInitialisierung.equals(rhs.letzteInitialisierung))))&&((this.startMeldung == rhs.startMeldung)||((this.startMeldung!= null)&&this.startMeldung.equals(rhs.startMeldung))))&&((this.letzteStartzeit == rhs.letzteStartzeit)||((this.letzteStartzeit!= null)&&this.letzteStartzeit.equals(rhs.letzteStartzeit))))&&((this.letzteStoppzeitSeconds == rhs.letzteStoppzeitSeconds)||((this.letzteStoppzeitSeconds!= null)&&this.letzteStoppzeitSeconds.equals(rhs.letzteStoppzeitSeconds))))&&((this.letzteStartzeitSeconds == rhs.letzteStartzeitSeconds)||((this.letzteStartzeitSeconds!= null)&&this.letzteStartzeitSeconds.equals(rhs.letzteStartzeitSeconds))))&&((this.inkarnation == rhs.inkarnation)||((this.inkarnation!= null)&&this.inkarnation.equals(rhs.inkarnation))))&&((this.letzteStoppzeit == rhs.letzteStoppzeit)||((this.letzteStoppzeit!= null)&&this.letzteStoppzeit.equals(rhs.letzteStoppzeit))))&&((this.anzahlStarts == rhs.anzahlStarts)||((this.anzahlStarts!= null)&&this.anzahlStarts.equals(rhs.anzahlStarts))))&&((this.additionalProperties == rhs.additionalProperties)||((this.additionalProperties!= null)&&this.additionalProperties.equals(rhs.additionalProperties))))&&((this.geaendert == rhs.geaendert)||((this.geaendert!= null)&&this.geaendert.equals(rhs.geaendert))))&&((this.status == rhs.status)||((this.status!= null)&&this.status.equals(rhs.status))));
    }


    /**
     * der Status der Inkarnation in StartStopp
     * 
     */
    public enum Status {

        INSTALLIERT("installiert"),
        STARTENWARTEN("startenwarten"),
        GESTARTET("gestartet"),
        INITIALISIERT("initialisiert"),
        STOPPENWARTEN("stoppenwarten"),
        GESTOPPT("gestoppt");
        private final String value;
        private final static Map<String, Applikation.Status> CONSTANTS = new HashMap<String, Applikation.Status>();

        static {
            for (Applikation.Status c: values()) {
                CONSTANTS.put(c.value, c);
            }
        }

        private Status(String value) {
            this.value = value;
        }

        @Override
        public String toString() {
            return this.value;
        }

        @JsonValue
        public String value() {
            return this.value;
        }

        @JsonCreator
        public static Applikation.Status fromValue(String value) {
            Applikation.Status constant = CONSTANTS.get(value);
            if (constant == null) {
                throw new IllegalArgumentException(value);
            } else {
                return constant;
            }
        }

    }

}
